/*********************************************
* Nombre: Clase Patrn 
* Copyright: PTK
* Autor: Aitor Hernndez Hernndez Alu2648
* Fecha de realizacin: 29 de octubre del 2005
* Descripcin: Archivo cabecera de la clase patron
* Clase encargada de generar un patrn
*********************************************/

#include "Patron.h"


/*************************************************************************/
// Constructor por defecto necesario para embeber este objeto dentro de otro
Patron::Patron () {   
}  


/*************************************************************************/
// Constructor de la clase patron, la variable info indica si se infooma o no
Patron::Patron (const unsigned tamano, const unsigned formaY, const unsigned formaX, bool info) {  
  creapatron (tamano, formaY, formaX, info);
}  


/*************************************************************************/
// Mtodo que crea un patrn pidiendo informacin al usuario
void Patron::creapatron (const unsigned tamano, const unsigned formaY, const unsigned formaX, bool info) {
  tam = tamano;
  tamx = formaX;
  tamy = formaY;
  patronactual.setformato (formaY, formaX);
  for (int i = 0; i < tam; i++) {
    banderas.push_back (false);
  }  
  if (info)
    mensajes (INDICAPOS);
  mensajes (POSICION);
  string posentrada = "";
  cin >> posentrada;
  abanderar (posentrada);
  if (info)
    mensajes (LIMPIAWINDOWS);   // Campiar por LIMPIALINUX y compilar en el otro SO
  if (info)
    mensajes (RELLENAINFO);
  mensajes (VALORELLENO);
  string valores = "";
  cin >> valores;
  extraeval (valores);
  generapatron(); 
  mensajes (LIMPIAWINDOWS);   // Campiar por LIMPIALINUX y compilar en el otro SO 
}  


/*************************************************************************/
// Metodo que transforma el string de entrada a un vector de banderas booleanas
// para su posterior uso
void Patron::abanderar (const string pos) {
  const unsigned TAMPOS = pos.length();  
  for (int i = 0; i < TAMPOS; i++) {
    unsigned lugar = 0;
    if (isdigit (pos[i])) {        
      lugar = atoi (&pos[i]); 
      lugar--;                                     // se hace coincidir las posiciones humanas con las de la representacin           
      if (lugar < 0) {
        lugar = 0;
        mensajes (ERRORLUGAR);
      }
      if (lugar < tam)
        banderas[lugar] = true;
      else
        mensajes (TAMAYOR);                        // error de tamao que se ignorar
      do { 
        i++;
      } while ((i < TAMPOS) & (pos[i] != COMA));   // avanzamos mientras haya nmeros
    } // si es un digito
                                              // PARTE QUE DETECTA RANGOS
    if (pos[i] == CORCHETE) {
      i++;                                       // Quitamos el corchete
      lugar = atoi (&pos[i]);
      lugar--;
      if (lugar < 0) {
        lugar = 0;
        mensajes (ERRORLUGAR);
      }
      do {
        i++;
      } while ((i < TAMPOS) & (pos[i] != COMA)); // avanzamos mientras haya nmeros
      if (pos[i] != COMA) {
        mensajes (ERRORFORMATO);                 // validacin del formato
        exit (1);
      }
      i++;                                       // nos saltamos la coma
      int lugar2 = 0;
      lugar2 = atoi (&pos[i]);
      lugar2--;
      if (lugar2 < 0) {
        lugar2 = 0;
        mensajes (ERRORLUGAR);                   // validacin del formato y coherencia de rango
      } else if (lugar2 < lugar) {
        mensajes (ERRORANGOLUGAR);
        exit (1);
      } else if (lugar2 >= tam) {
        mensajes (TAMAYORANGO);
        lugar2 = tam-1;
      }  
      do {
        i++;
      } while ((i < TAMPOS) & (pos[i] != CROCHETE)); // avanzamos mientras haya nmeros
      if (pos[i] != CROCHETE) {
        mensajes (ERRORFORMATO);                     // validacin del formato
        exit (1);
      }
      for (int j = lugar; j <= lugar2; j++) {
        banderas[j] = true;
      } // para cada valor se marca en las banderas      
      i++;                                        // Quitamos el corchete
    } // Si es abre corchete
  } // para cada elemento de la cadena  
}


/*************************************************************************/
// Metodo que extrae los valores indicados pos el usuario detectando si hay
// que generar aleatorios y los guarda consecuitivamente.
void Patron::extraeval (const string val){
  const unsigned TAMVAL = val.length();
  for (int i = 0; i < TAMVAL; i++) {
    int valor = 0;
                                              // PARTE QUE DETECTA NUMEROS SUELTOS
    if ((isdigit (val[i])) | (val[i] == MENOS)) {
      valor = atoi (&val[i]);
      Rango numero (valor, valor);
      valores.push_back (numero);
      do {
        i++;
      } while ((i < TAMVAL) & (val[i] != COMA)); // avanzamos mientras haya nmeros
    } // si es un dgito
                                              // PARTE QUE DETECTA RANGOS
    if (val[i] == CORCHETE) {
      i++;                                       // Quitamos el corchete
      valor = atoi (&val[i]);
      do {
        i++;
      } while ((i < TAMVAL) & (val[i] != COMA)); // avanzamos mientras haya nmeros
      if (val[i] != COMA) {
        mensajes (ERRORFORMATO);                 // validacin del formato
        exit (1);
      }
      i++;                                       // nos saltamos la coma
      int valor2 = 0;
      valor2 = atoi (&val[i]);
      do {
        i++;
      } while ((i < TAMVAL) & (val[i] != CROCHETE)); // avanzamos mientras haya nmeros
      if (val[i] != CROCHETE) {
        mensajes (ERRORFORMATO);                     // validacin del formato
        exit (1);
      }
      Rango rango (valor,valor2);
      valores.push_back (rango);
      i++;                                        // Quitamos el corchete
    } // Si es abre corchete
  } // para cada elemento de la cadena
} // extrae val


/*************************************************************************/
// Metodo que usa las banderas y los valores para generar el patrn asignando
// el ltimo valor dado al resto de posiciones indicadas por el usuario si hay ms posiciones que valores
void Patron::generapatron (void) {
  int j = 0;
  const int TAMVAL = valores.size();
  for (int i = 0; i < tam; i++) {
    if (banderas[i]) {
      patronactual.setval (valores[j].getnum ());
      if ((j + 1) < TAMVAL)
        j++;                  // as se asigna siempre el ltimo valor al resto de lugares sealados
    }
    else {
      patronactual.setval (0.0);
    }    
  } // para cada posicin del total del tamao del patrn
}


/*************************************************************************/
// Metodo que contiene los mensajes para el usuario todos juntos
void Patron::mensajes (Tmsg msg) const {
  switch (msg) {
    case INDICAPOS: cout << "\nIndique las posiciones o rangos dentro del patrn que contendrn nmeros\ndistintos de cero. Para ello use una sintxis como la del ejemplo.\n\nEn este ejemplo: 1,[5,9],3,13,[20,40],42\nSe indica que los nmeros que ocupan esas posiciones y los que estn dentro\nde los rangos indicados contendrn valores distintos de cero.\n\nNote que estn separados por comas y sin espacios.\n" << endl; break;
    case POSICION: cout << "indique la/s posicin/es: "; break;
    case TAMAYOR: cout << "Se ha indicado una posicin mayor que el tamao de entrada, ser ignorado" << endl; break;
    case LIMPIAWINDOWS: system ("cls"); break;
    case LIMPIALINUX: system ("clear"); break;
    case RELLENAINFO: cout << "\nA continuacin se espera que usted escriba los valores separados por comas que\ntomarn los nmeros situados en las posiciones cedidas con anterioridad.\n\nSi especifica menos valores que posiciones se repetir el ltimo valor cedido\npara todas las posiciones restantes.\nTambin puede asignar un nmero aleatorio con la siguiente sintxis:\n[N,M] con N y M nmeros enteros.\n\nEjemplo: 1,[0,10],5,3,[0,1]" << endl; break;
    case VALORELLENO: cout << "\nValor/es: "; break;
    case ERRORFORMATO: cout << "Ha introducido mal el formato de los nmeros, el programa se cerrar." << endl; break;
    case ERRORLUGAR: cout << "La posicin dada no existe. Se le ha asignado la primera posicin."; break;
    case ERRORANGOLUGAR: cout << "Ha introducido un rango invlido. Se aborta el programa" << endl; break;
    case TAMAYORANGO: cout << "Ha introducido un rango superior mayor que el tamao del patrn.\nSe tomar como final del rango el tamao mximo del patrn" << endl; break;
  }
}


/*************************************************************************/
// Metodo que muestra la entrada y salida usando la sobrecarga
ostream& Patron::mostrar (ostream &sout) {
  sout << patronactual;
  return (sout);
}  


//**********************************
// sobrecarga de operadores externos
//**********************************

/*************************************************************************/
// sobrecarga para mostrar una ristra completa. Da una salida formateada 
// convenientemente
ostream& operator << (ostream &sout, Patron &patron) {
  return (patron.mostrar (sout));
}  




