/*********************************************
* Nombre: Clase Ristra
* Copyright: PTK
* Autor: Aitor Hernndez Hernndez Alu2648
* Fecha de realizacin: 29 de octubre del 2005
* Descripcin: Archivo cabecera de la clase ristra
* Clase encargada de generar una ristra de nmeros
* naturales separados por espacio y acabados en el caracter "\n"
*********************************************/

#include "Ristra.h"


/*************************************************************************/
// Constructor de la clase ristra
Ristra::Ristra () {  
}  


/*************************************************************************/
// Metodo que inserta un elemento en la ristra de nmeros por el final
void Ristra::setval (const double num) {
  buffer.push_back (num);  
}  


/*************************************************************************/
// Metodo que guarda el formato para ser usado al mostrar la ristra
void Ristra::setformato (const unsigned formaY, const unsigned formaX) {
  formatoY = formaY; 
  formatoX = formaX;
}  


/*************************************************************************/
// Metodo que devuelve el nmero situado en la posicin pos
double Ristra::getval (const unsigned pos) {
  if (pos >= buffer.size ()) {
    cout << "ERROR: Se ha intentado acceder a una posicin fuera de la ristra" << endl;
    exit (1);
  }  
  return (buffer[pos]);
}  


/*************************************************************************/
// Metodo que muestra la ristra formateada convenientemente
ostream& Ristra::mostrar (ostream &sout) {
  unsigned j = 0;
  unsigned k = 0;
  const unsigned TAM = buffer.size();
  const unsigned TAMZ = TAM/(formatoX*formatoY);
  for (int i = 0; i < TAM; i++) {
    sout.precision(6);
    sout << buffer[i];
    k++;
    if (k == formatoX) {
      sout << endl;
      k = 0;
      j++;
      if (j == formatoY) {        
        sout << endl;
        j = 0;
      }
    }
    else if (i < TAM - 1)
      sout << " ";
    else
      sout << endl;
  }  // para todo nmero
  return (sout);
}  


//**********************************
// sobrecarga de operadores externos
//**********************************

/*************************************************************************/
// sobrecarga para mostrar una ristra completa. Da una salida formateada 
// convenientemente
ostream& operator << (ostream &sout, Ristra &ristra) {
  return (ristra.mostrar (sout));
}  




